<?php
/**
 * Copyright 2011 Jesse LaBrocca, All Rights Reserved
 * Plugin: My Ad Manager v1.2
 * Website: http://mybbcentral.com
 * License: http://mybbcentral.com/license.php
 *
 */ 


// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
    $init_check = "&#77-121-98-98-32-67-101-110-116-114-97-108;";
    $init_error = str_replace("-",";&#", $init_check);
    die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.<br />". $init_error);
} 

$plugins->add_hook("postbit","myads_inline");
$plugins->add_hook("pre_output_page", "myads");


function my_ad_manager_info()
{
	global $lang;
	$lang->load("my_ad_manager");

	return array(
		"name"			=> "My Ad Manager",
		"description"	=> $lang->description,
		"website"		=> "http://www.mybbcentral.com",
		"author"		=> "Jesse Labrocca",
		"authorsite"	=> "http://www.mybbcentral.com",
		"version"		=> "1.2",
		"guid" 			=> "",
		"compatibility" => "16*"
	);
}


function my_ad_manager_install()
{
	global $mybb, $db, $lang;
	$lang->load("my_ad_manager");

    $my_ad_manager_group = array(
        "name" => "myadmanager",
        "title" => $lang->my_ad_manager,
        "description" => $lang->settingsgroup,
        "disporder" => "30",
        "isdefault" => "0",
        );
    $db->insert_query("settinggroups", $my_ad_manager_group);
    $gid = $db->insert_id();


    $setting_1 = array(
        "name" => "inlineadenable",
        "title" => $lang->enable_inline_ads,
        "description" => $lang->enable_between_posts,
        "optionscode" => "onoff",
        "value" => "0",
        "disporder" => "1",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_1);

    $setting_2 = array(
        "name" => "inlinead",
        "title" => $lang->inline_ad,
        "description" => $lang->enter_inline,
        "optionscode" => "textarea",
        "value" => "",
        "disporder" => "2",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_2);

    $setting_3 = array(
        "name" => "inadexemptg",
        "title" => $lang->exempt_group_inline,
        "description" => $lang->exempt_group_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "3",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_3);

    $setting_4 = array(
        "name" => "inadexemptf",
        "title" => $lang->exempt_forum_inline,
        "description" => $lang->exempt_forum_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "4",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_4);

    $setting_5 = array(
        "name" => "inadmode",
        "title" => $lang->inline_ad_mode,
        "description" => $lang->inline_ad_mode_choice,
        "optionscode" => "radio\r\n1={$lang->inline_ad_mode_1} \r\n2={$lang->inline_ad_mode_2}\r\n3={$lang->inline_ad_mode_3}",
        "value" => "2",
        "disporder" => "5",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_5);

    $setting_6 = array(
        "name" => "inadpostnum",
        "title" => $lang->inline_ad_posts,
        "description" => $lang->inline_ad_posts_choice,
        "optionscode" => "text",
        "value" => "5",
        "disporder" => "6",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_6);

    $setting_7 = array(
        "name" => "headadenable",
        "title" => $lang->enable_headerinclude_ads,
        "description" => $lang->enable_headerinclude_ads_template,
        "optionscode" => "onoff",
        "value" => "0",
        "disporder" => "7",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_7);

    $setting_8 = array(
        "name" => "headad",
        "title" => $lang->headerinclude_ad,
        "description" => $lang->headerinclude_ad_desc,
        "optionscode" => "textarea",
        "value" => "",
        "disporder" => "8",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_8);

    $setting_9 = array(
        "name" => "hadexemptg",
        "title" => $lang->exempt_group_headerinclude,
        "description" => $lang->exempt_group_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "9",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_9);

    $setting_10 = array(
        "name" => "hadexemptf",
        "title" => $lang->exempt_forum_headerinclude,
        "description" => $lang->exempt_forum_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "10",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_10);

    $setting_11 = array(
        "name" => "topadenable",
        "title" => $lang->enable_top_ads,
        "description" => $lang->enable_top_ads_template,
        "optionscode" => "onoff",
        "value" => "0",
        "disporder" => "11",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_11);

    $setting_12 = array(
        "name" => "topad",
        "title" => $lang->top_ad_code,
        "description" => $lang->top_ad_code_edit,
        "optionscode" => "textarea",
        "value" => "",
        "disporder" => "12",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_12);

    $setting_13 = array(
        "name" => "tadexemptg",
        "title" => $lang->exempt_group_top,
        "description" => $lang->exempt_group_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "13",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_13);

    $setting_14 = array(
        "name" => "tadexemptf",
        "title" => $lang->exempt_forum_top,
        "description" => $lang->exempt_forum_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "14",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_14);

    $setting_15 = array(
        "name" => "footadenable",
        "title" => $lang->enable_footer_ads,
        "description" => $lang->enable_footer_ads_template,
        "optionscode" => "onoff",
        "value" => "0",
        "disporder" => "15",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_15);

    $setting_16 = array(
        "name" => "footad",
        "title" => $lang->footer_ad_code,
        "description" => $lang->footer_ad_code_edit,
        "optionscode" => "textarea",
        "value" => "",
        "disporder" => "16",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_16);

    $setting_17 = array(
        "name" => "fadexemptg",
        "title" => $lang->exempt_group_footer,
        "description" => $lang->exempt_group_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "17",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_17);

    $setting_18 = array(
        "name" => "fadexemptf",
        "title" => $lang->exempt_forum_footer,
        "description" => $lang->exempt_forum_list,
        "optionscode" => "text",
        "value" => "0",
        "disporder" => "18",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $setting_18);

}


function my_ad_manager_is_installed()
{
	global $db;
	$query = $db->simple_select("settings", "name", "name='fadexemptg'");
	$rows = $db->num_rows($query);

	if(intval($rows) == 1)
	{
		return true;
	}
	
	return false;
}


function my_ad_manager_activate()
{
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';

	find_append_templatesets("postbit", "{\$post[inline_ad]}");
	find_append_templatesets("postbit_classic", "{\$post[inline_ad]}");

}

function my_ad_manager_deactivate()
{
    require "../inc/adminfunctions_templates.php";
	find_replace_templatesets("postbit", '#'.preg_quote('{$post[inline_ad]}').'#', '',0);
	find_replace_templatesets("postbit_classic", '#'.preg_quote('{$post[inline_ad]}').'#', '',0);
	rebuild_settings();
}

function my_ad_manager_uninstall()
{
	global $db;
	$query = $db->query("SELECT gid FROM ".TABLE_PREFIX."settinggroups WHERE name='myadmanager'");
    $g = $db->fetch_array($query);
    $db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE gid='".$g['gid']."'");
    $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE gid='".$g['gid']."'");

	rebuild_settings();
}



function myads_inline(&$post)
{

global $mybb, $db, $postcounter, $fid;


 if($mybb->settings['inlineadenable'])
 {

	$gexempt = explode(",",$mybb->settings['inadexemptg']);
	$fexempt = explode(",",$mybb->settings['inadexemptf']);

	 if ( (in_array($mybb->user['usergroup'],$gexempt)) || (in_array($fid,$fexempt)) )
		{

	   return $post;
		}


	switch ($mybb->settings['inadmode'])
	{
	case 1:
        if (($postcounter - 1) % $mybb->settings['postsperpage'] == "0") {
		$ad = true;
		}
    break;

	case 2:
        if ($postcounter == "1" || ($postcounter - 1) % ($mybb->settings['inadpostnum']) == "0") {
		$ad = true;
		}
    break;

	case 3:
        if ($postcounter % ($mybb->settings['inadpostnum']) == "0") {
		$ad = true;
		}
    break;
	}

	if($ad){
		$post[inline_ad] = "<div align=\"center\" class=\"inlinead\">".$mybb->settings['inlinead']."</div>";
	}

   
 }

   return $post;
 
}


function myads(&$page)
{

	global $mybb, $db, $fid;


	if($mybb->settings['headadenable'])
	{

	$gexempt = explode(",",$mybb->settings['hadexemptg']);
	$fexempt = explode(",",$mybb->settings['hadexemptf']);

	 if ( (!in_array($mybb->user['usergroup'],$gexempt)) && (!in_array($fid,$fexempt)) )
		{	
		$page = preg_replace('#'.preg_quote('<!-- end: headerinclude -->').'#', $mybb->settings['headad'] ."
<!-- end: headerinclude -->", $page);

		}
	}

	if($mybb->settings['topadenable'])
	{


	$gexempt = explode(",",$mybb->settings['tadexemptg']);
	$fexempt = explode(",",$mybb->settings['tadexemptf']);

	 if ( (!in_array($mybb->user['usergroup'],$gexempt)) && (!in_array($fid,$fexempt)) )
		{

		$page = preg_replace('#'.preg_quote('<!-- end: header -->').'#', "<div class=\"headerad\" align=\"center\">". $mybb->settings['topad'] ."</div><!-- end: header -->", $page);

		}

	}

	if($mybb->settings['footadenable'])
	{

	$gexempt = explode(",",$mybb->settings['fadexemptg']);
	$fexempt = explode(",",$mybb->settings['fadexemptf']);

	 if ( (!in_array($mybb->user['usergroup'],$gexempt)) && (!in_array($fid,$fexempt)) )
		{

		$page = preg_replace('#'.preg_quote('<!-- start: footer -->').'#', "<!-- start: footer --><div class=\"footerad\" align=\"center\">". $mybb->settings['footad'] ."</div>", $page);

		}	
		
	}

	return $page;

}

function find_append_templatesets($title, $append, $autocreate=1)
{
	global $db;
	if($autocreate != 0)
	{
		$query = $db->simple_select("templates", "*", "title='$title' AND sid='-2'");
		$master = $db->fetch_array($query);
		$oldmaster = $master['template'];
		$master['template'] = $master['template'] . $append;
		if($oldmaster == $master['template'])
		{
			return false;
		}
		$master['template'] = $db->escape_string($master['template']);
	}
	$query = $db->query("
		SELECT s.sid, t.template, t.tid 
		FROM ".TABLE_PREFIX."templatesets s 
		LEFT JOIN ".TABLE_PREFIX."templates t ON (t.title='$title' AND t.sid=s.sid)
	");
	while($template = $db->fetch_array($query))
	{
		if($template['template']) // Custom template exists for this group
		{
			if(!$template['template'])
			{
				return false;
			}
			$newtemplate = $template['template'] . $append;
			$template['template'] = $newtemplate;
			$update[] = $template;
		}
		elseif($autocreate != 0) // No template exists, create it based off master
		{
			$newtemp = array(
				"title" => $title,
				"template" => $master['template'],
				"sid" => $template['sid']
			);
			$db->insert_query("templates", $newtemp);
		}
	}
	
	if(is_array($update))
	{
		foreach($update as $template)
		{
			$updatetemp = array("template" => $db->escape_string($template['template']), "dateline" => TIME_NOW);
			$db->update_query("templates", $updatetemp, "tid='".$template['tid']."'");
		}
	}
	return true;
}

?>